import { LRParser } from '@lezer/lr';
import { LRLanguage, HighlightStyle, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQVQPOOOnQPO'#CfOOQO'#Ck'#CkOOQO'#Cg'#CgQVQPOOOOQO,59Q,59QOuQPO,59QOOQO-E6e-E6eOOQO1G.l1G.l",
  stateData: "!P~O^OS~OQQORQOSQOTQOUQOVQOXPO~OWTO~PVOWWO~PVOTQ~",
  goto: "w`PPPPPPPPPPagPPPqXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ NuFormula Operator Keyword String Number VariableName Comma ) ( Function",
  maxTerm: 15,
  nodeProps: [
    ["openedBy", 8,"("],
    ["closedBy", 9,")"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: ")t~RcXY!^YZ!^]^!^pq!^rs!cxy${yz%Qz{%V{|%[|}&Q}!O%[!O!P%g!P!Q%V!Q![%u!^!_&V!_!`%V!`!a&b!c!}&j#o#p&r~!cO^~~!fWpq!cqr!crs#Os#O!c#O#P#T#P;'S!c;'S;=`$u<%lO!c~#TOS~~#WXrs!c!P!Q!c#O#P!c#U#V!c#Y#Z!c#b#c!c#f#g!c#h#i!c#i#j#s~#vR!Q![$P!c!i$P#T#Z$P~$SR!Q![$]!c!i$]#T#Z$]~$`R!Q![$i!c!i$i#T#Z$i~$lR!Q![!c!c!i!c#T#Z!c~$xP;=`<%l!c~%QOX~~%VOW~~%[OQ~~%aQQ~!O!P%g!Q![%u~%jP!Q![%m~%rPT~!Q![%m~%zQT~!O!P%m!Q![%u~&VOV~~&[QQ~!_!`%V!`!a%V~&gPQ~!_!`%V~&oPR~!c!}&j~&uR!Q!['O!c!i'O#T#Z'O~'RS}!O'_!Q!['O!c!i'O#T#Z'O~'bR!Q!['k!c!i'k#T#Z'k~'nS}!O'z!Q!['k!c!i'k#T#Z'k~'}R!Q![(W!c!i(W#T#Z(W~(ZS}!O(g!Q![(W!c!i(W#T#Z(W~(jR!Q![(s!c!i(s#T#Z(s~(vS}!O)S!Q![(s!c!i(s#T#Z(s~)VR!Q![)`!c!i)`#T#Z)`~)cS!Q![)`!c!i)`#T#Z)`#q#r)o~)tOU~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 44
});

// 定義語言
const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                VariableName: tags.variableName,
                "( )": tags.paren,
                Comma: tags.separator,
            }),
        ],
    }),
});
// 語言標籤樣式
const nuformulaHighlightStyle = HighlightStyle.define([
    { tag: tags.keyword, color: "#B157D0" },
    { tag: tags.string, color: "#F7A452" },
    { tag: tags.number, color: "#5C9CE5" },
    { tag: tags.operator, color: "#404040" },
    { tag: tags.variableName, color: "#6E7796" },
]);
// 輸出語言
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula, nuformulaHighlightStyle };
